package org.netbeans.example;

import javax.annotation.PostConstruct;
import javax.annotation.PreDestroy;
import javax.interceptor.AroundConstruct;
import javax.interceptor.AroundInvoke;
import javax.interceptor.InvocationContext;

/**
 *
 * @author jGauravGupta
 */
public class SampleInterceptor {

    @PostConstruct
    public void init(InvocationContext context) throws Exception {
        System.out.println("SampleInterceptor > PostConstruct > init");
        context.proceed();
    }

    @AroundConstruct
    public Object construct(InvocationContext context) throws Exception {
        System.out.println("SampleInterceptor > construct");
        return context.proceed();
    }

    @AroundInvoke
    public Object invoke(InvocationContext context) throws Exception {
        System.out.println("SampleInterceptor > invoke");
        return context.proceed();
    }

    @PreDestroy
    public void destroy(InvocationContext context) throws Exception {
        System.out.println("SampleInterceptor > PreDestroy > destroy");
        context.proceed();
    }
}
